
clear
set mem 2g
set matsize 800

*** construction of the labor composite and implementation of regressions to estimate 1/sigma_exp using the inverted nest****

cd H:\Giovanni\MyPapers\Peri_Ottaviano_aggregate\REDUX_2008_2010\empirics_revision_winter_2010\regression_IPUMS
use supply_groups_60_06_specification_1.dta
sort year edu exp
save employment, replace
clear
use supply_wage_60_06_specification_1
sort year edu exp
merge year edu exp using employment
sort edu year

**** DUMMIES
gen eduyear=year+edu
gen eduexp=(edu*10)+exp
gen expyear=year*10+exp

tab eduyear, gen (edy)
tab eduexp, gen(edex)
tab expyear, gen(exy)


*** supply index for edu-exp group

gen howo_us=howo_ma_us+howo_fe_us
gen howo_for=howo_ma_for+howo_fe_for
gen howo_male=howo_ma_us+howo_ma_for
gen howo_female=howo_fe_us+howo_fe_for

gen lnhowo=ln(howo_ma_us+howo_fe_us+howo_ma_for+howo_fe_for)
gen lnhowo_for=ln(howo_fe_for+howo_ma_for)
gen lnhowo_male=ln(howo_ma_us+howo_ma_for)
gen lnhowo_male_for=ln(howo_ma_for)
gen lnhowo_female=ln(howo_fe_us+howo_fe_for)
gen lnhowo_female_for=ln(howo_fe_for)

** employed bodies in log variables
gen empl_us=empl_ma_us+empl_fe_us
gen empl_for=empl_ma_for+empl_fe_for
gen lnempl=ln(empl_ma_us+empl_fe_us+empl_ma_for+empl_fe_for)
gen lnempl_male=ln(empl_ma_us+empl_ma_for)
gen lnempl_female=ln(empl_fe_us+empl_fe_for)
gen lnempl_for=ln(empl_ma_for+empl_fe_for)
gen lnempl_ma_for=ln(empl_ma_for)
gen lnempl_fe_for=ln(empl_fe_for)


*******************
* generate variables for the 1/sigma_immi regression***

gen lnrel_hours=ln((howo_ma_for+howo_fe_for)/(howo_ma_us+howo_fe_us))
gen lnrel_hours_male=ln(howo_ma_for/howo_ma_us)
gen lnrel_hours_female=ln(howo_fe_for/howo_fe_us)
gen lnrel_empl=ln((empl_ma_for+empl_fe_for)/(empl_ma_us+empl_fe_us))
gen lnrel_empl_male=ln(empl_ma_for/empl_ma_us)
gen lnrel_empl_female=ln(empl_fe_for/empl_fe_us)
gen weekly_for=(weekly_ma_for*howo_ma_for+weekly_fe_for*howo_fe_for)/(howo_ma_for+howo_fe_for)
gen weekly_us=(weekly_ma_us*howo_ma_us+weekly_fe_us*howo_fe_us)/(howo_ma_us+howo_fe_us)
gen lnrel_weekly= ln(weekly_for/weekly_us)
gen lnrel_weekly_male= ln(weekly_ma_for/weekly_ma_us)
gen lnrel_weekly_female= ln(weekly_fe_for/weekly_fe_us)

** basic 1/sigma_immi regression pooled, construct the theta
xi:reg lnrel_weekly lnrel_hours i.edu*i.exp [aw=employment], robust cluster(eduexp)
predict e_pool, resid
gen base_kj_pool= lnrel_weekly +0.027*lnrel_hours-e_pool
gen theta_Fkj_pool=exp(base_kj_pool)/(1+exp(base_kj_pool))


** construction of L_kjt in the case of imperfect subst, assuming sigma_immi =20
gen N_kj_pooled_hours=[theta_Fkj_pool*(howo_for^0.95)+(1-theta_Fkj_pool)*(howo_us^0.95)]^(1.052)
gen N_kj_pooled_employment=[theta_Fkj_pool*(empl_for^0.95)+(1-theta_Fkj_pool)*(empl_us^0.95)]^(1.052)

gen lnN_kj_pooled_hours=ln(N_kj_pooled_hours)
gen lnN_kj_pooled_employment=ln(N_kj_pooled_employment)


***********************************


** weekly wages
gen weekly=(weekly_ma_us*howo_ma_us+weekly_fe_us*howo_fe_us+weekly_ma_for*howo_ma_for+weekly_fe_for*howo_fe_for)/howo
gen weekly_male=(weekly_ma_us*howo_ma_us+weekly_ma_for*howo_ma_for)/(howo_ma_us+howo_ma_for)
gen weekly_female=(weekly_fe_us*howo_fe_us+weekly_fe_for*howo_fe_for)/(howo_fe_us+howo_fe_for)

** log weekly wages variables
gen lnweekly=ln(weekly)
gen lnweekly_male=ln(weekly_male)
gen lnweekly_female=ln(weekly_female)


**imperfect subst within the edu group, pooled workers

**imperfect subst in the edu group, pooled males and female
xi:ivreg lnweekly (lnN_kj_pooled_hours=lnhowo_for) i.edu*i.exp i.edu*i.year i.exp*i.year [aw=employment],robust cluster(eduexp)
predict e_jt_pooled_imp

gen base_jt_pooled_imp=lnweekly +0.05*lnN_kj_pooled_hours-e_jt_pooled_imp
replace base_jt_pooled_imp=exp(base_jt_pooled_imp)

egen sum_jt_pooled_imp=sum(base_jt_pooled_imp), by (year exp)
gen theta_jt_pooled_imp=base_jt_pooled_imp/sum_jt_pooled_imp
gen term_jt_pooled_imp=(theta_jt_pooled_imp)*((N_kj_pooled_hours)^0.78)
egen index_jt_pooled_imp=sum(term_jt_pooled_imp), by(year exp)
gen N_j_pooled_imp=index_jt_pooled_imp^1.28

*** perf susbt in the exp group, pooled male and female
egen N_j_pooled_perf=sum(howo), by (year exp)


** imperfect susbt, employment based
gen term_jt_pooled_imp_empl=(theta_jt_pooled_imp)*((N_kj_pooled_employment)^0.78)
egen index_jt_pooled_imp_empl=sum(term_jt_pooled_imp_empl), by(year exp)
gen N_j_pooled_imp_empl=index_jt_pooled_imp_empl^1.28

*** perf susbt in the edu group employment based, pooled male and female
egen N_j_pooled_perf_empl=sum(employment), by (year exp)


** weekly wages
gen week_bill=weekly*howo
gen week_bill_male=(weekly_ma_us*howo_ma_us+weekly_ma_for*howo_ma_for)
gen week_bill_female=(weekly_fe_us*howo_fe_us+weekly_fe_for*howo_fe_for)

collapse (sum) week_bill week_bill_male week_bill_female employment empl_us empl_for empl_ma_for empl_fe_for howo howo_us howo_for howo_ma_for howo_fe_for howo_male howo_female (mean) N_j_pooled_imp N_j_pooled_imp_empl N_j_pooled_perf N_j_pooled_perf_empl, by (year exp)

gen weekly=week_bill/howo
gen weekly_ma=week_bill_male/howo_male
gen weekly_fe=week_bill_female/howo_female


tab exp, gen(ex)
gen time1=ex1*(year-1960)
gen time2=ex2*(year-1960)
gen time3=ex3*(year-1960)
gen time4=ex4*(year-1960)
gen time5=ex5*(year-1960)
gen time6=ex6*(year-1960)
gen time7=ex7*(year-1960)
gen time8=ex8*(year-1960)

tab year, gen (y)

*** generate the logs of the CES experience-specific composite
gen lnN_j_pooled=ln(N_j_pooled_imp)
gen lnN_j_pooled_empl=ln(N_j_pooled_imp_empl)


gen lnhowo_for=ln(howo_for)
gen lnempl_for=ln(empl_for)

gen lnweekly=ln(weekly)
gen lnweekly_ma=ln(weekly_ma)
gen lnweekly_fe=ln(weekly_fe)


*** Estimates of 1/sigma_exp inverted nest, Table 3 columns 4, first specificaiton is the basic one

**row 1 males

ivreg lnweekly_ma (lnN_j_pooled=lnhowo_for) ex1-ex8 y1-y6 [aweight=employment], robust cluster (exp)
ivreg lnweekly_ma (lnN_j_pooled=lnhowo_for) time1-time8 ex1-ex8 [aweight=employment], robust cluster (exp)

*** row 2 female
ivreg lnweekly_fe (lnN_j_pooled=lnhowo_for) ex1-ex8 y1-y6 [aweight=employment], robust cluster (exp)
ivreg lnweekly_fe (lnN_j_pooled=lnhowo_for) time1-time8 ex1-ex8 [aweight=employment], robust cluster (exp)

**row 3 pooled
ivreg lnweekly (lnN_j_pooled=lnhowo_for) ex1-ex8 y1-y6 [aweight=employment], robust cluster (exp)
ivreg lnweekly (lnN_j_pooled=lnhowo_for) time1-time8 ex1-ex8 [aweight=employment], robust cluster (exp)

**row 4 pooled, employment
ivreg lnweekly (lnN_j_pooled_empl=lnempl_for) ex1-ex8 y1-y6 [aweight=employment], robust cluster (exp)
ivreg lnweekly (lnN_j_pooled_empl=lnempl_for) time1-time8 ex1-ex8 [aweight=employment], robust cluster (exp)




