
clear
set mem 2g
set matsize 800

*** Be careful to what specification of the wage and employment file you  load
** the description of each specification is in the file 
cd H:\Giovanni\MyPapers\Peri_Ottaviano_aggregate\REDUX_2008_2010\empirics_revision_winter_2010\regression_IPUMS


use supply_groups_60_06_specification_1.dta
sort year edu exp
save employment, replace
clear
use supply_wage_60_06_specification_fulltime
sort year edu exp
merge year edu exp using employment


* generate dummies 
gen eduyear=year+edu
gen eduexp=(edu*10)+exp
gen expyear=year*10+exp

tab exp, gen(ex)
tab edu, gen (edu)
tab year, gen (y)
tab eduyear, gen (edy)
tab eduexp, gen(edex)
tab expyear, gen(exy)

* generate variables ***

gen lnrel_hours=ln((howo_ma_for+howo_fe_for)/(howo_ma_us+howo_fe_us))
gen lnrel_hours_male=ln(howo_ma_for/howo_ma_us)
gen lnrel_hours_female=ln(howo_fe_for/howo_fe_us)

gen lnrel_empl=ln((empl_ma_for+empl_fe_for)/(empl_ma_us+empl_fe_us))
gen lnrel_empl_male=ln(empl_ma_for/empl_ma_us)
gen lnrel_empl_female=ln(empl_fe_for/empl_fe_us)

gen weekly_for=(weekly_ma_for*howo_ma_for+weekly_fe_for*howo_fe_for)/(howo_ma_for+howo_fe_for)
gen weekly_us=(weekly_ma_us*howo_ma_us+weekly_fe_us*howo_fe_us)/(howo_ma_us+howo_fe_us)

gen lnrel_weekly= ln(weekly_for/weekly_us)
gen lnrel_weekly_male= ln(weekly_ma_for/weekly_ma_us)
gen lnrel_weekly_female= ln(weekly_fe_for/weekly_fe_us)


*** Table 2
*Basic specifications, Male wages

xi:reg lnrel_weekly_male lnrel_hours [aw=employment], robust cluster(eduexp)
xi:reg lnrel_weekly_male lnrel_hours i.edu*i.exp i.year [aw=employment], robust cluster(eduexp)
xi:reg lnrel_weekly_male lnrel_hours i.edu*i.exp i.year, robust cluster(eduexp)


*** Table 2 
** Basic specificaiton female wages

xi:reg lnrel_weekly_female lnrel_hours [aw=employment], robust cluster(eduexp)
xi:reg lnrel_weekly_female lnrel_hours i.edu*i.exp i.year [aw=employment], robust cluster(eduexp)
xi:reg lnrel_weekly_female lnrel_hours i.edu*i.exp i.year, robust cluster(eduexp)


*** Table 2
*Male and female pooled

xi:reg lnrel_weekly lnrel_hours [aw=employment], robust cluster(eduexp)
xi:reg lnrel_weekly lnrel_hours i.edu*i.exp i.year [aw=employment], robust cluster(eduexp)
xi:reg lnrel_weekly lnrel_hours i.edu*i.exp i.year, robust cluster(eduexp)


*** Table 2
*Basic specifications, Male with relative employment

xi: reg lnrel_weekly_male lnrel_empl [aw=employment], robust cluster(eduexp)
xi: reg lnrel_weekly lnrel_empl i.edu*i.exp i.year [aw=employment], robust cluster(eduexp)
xi: reg lnrel_weekly lnrel_empl i.edu*i.exp i.year , robust cluster(eduexp)


*** Table 2
* Male by education group


xi:reg lnrel_weekly_male lnrel_hours if edu==1 [aw=employment], robust cluster(eduexp)
xi:reg lnrel_weekly_male lnrel_hours if edu==2 [aw=employment], robust cluster(eduexp)
xi:reg lnrel_weekly_male lnrel_hours if edu==3 [aw=employment], robust cluster(eduexp)
xi:reg lnrel_weekly_male lnrel_hours if edu==4 [aw=employment], robust cluster(eduexp)

xi:reg lnrel_weekly_male lnrel_hours i.exp if edu==1 [aw=employment], robust cluster(eduexp)
xi:reg lnrel_weekly_male lnrel_hours i.exp if edu==2 [aw=employment], robust cluster(eduexp)
xi:reg lnrel_weekly_male lnrel_hours i.exp if edu==3 [aw=employment], robust cluster(eduexp)
xi:reg lnrel_weekly_male lnrel_hours i.exp if edu==4 [aw=employment], robust cluster(eduexp)

xi:reg lnrel_weekly_male lnrel_hours i.exp if edu==1, robust cluster(eduexp)
xi:reg lnrel_weekly_male lnrel_hours i.exp if edu==2, robust cluster(eduexp)
xi:reg lnrel_weekly_male lnrel_hours i.exp if edu==3, robust cluster(eduexp)
xi:reg lnrel_weekly_male lnrel_hours i.exp if edu==4, robust cluster(eduexp)


*** Table 2
*Male by experience group

xi:reg lnrel_weekly_male lnrel_hours [aw=employment] if exp==1 |exp==2, robust cluster(eduexp)
xi:reg lnrel_weekly_male lnrel_hours [aw=employment] if exp==2 |exp==3, robust cluster(eduexp)
xi:reg lnrel_weekly_male lnrel_hours [aw=employment] if exp==4 |exp==5, robust cluster(eduexp)
xi:reg lnrel_weekly_male lnrel_hours [aw=employment] if exp==6 |exp==7, robust cluster(eduexp)

xi:reg lnrel_weekly_male lnrel_hours i.edu i.year [aw=employment] if exp==1 |exp==2, robust cluster(eduexp)
xi:reg lnrel_weekly_male lnrel_hours i.edu i.year  [aw=employment] if exp==3 |exp==4, robust cluster(eduexp)
xi:reg lnrel_weekly_male lnrel_hours i.edu i.year  [aw=employment] if exp==5 |exp==6, robust cluster(eduexp)
xi:reg lnrel_weekly_male lnrel_hours i.edu i.year  [aw=employment] if exp==7 |exp==8, robust cluster(eduexp)

xi:reg lnrel_weekly_male lnrel_hours i.edu i.year if exp==1 |exp==2, robust cluster(eduexp)
xi:reg lnrel_weekly_male lnrel_hours i.edu i.year if exp==3 |exp==4, robust cluster(eduexp)
xi:reg lnrel_weekly_male lnrel_hours i.edu i.year if exp==5 |exp==6, robust cluster(eduexp)
xi:reg lnrel_weekly_male lnrel_hours i.edu i.year if exp==7 |exp==8, robust cluster(eduexp)




















